<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template xmlns:the-="http://www.w3.org/1999/html">
  <v-app-bar class="studium-navbar" app :hide-on-scroll="hideOnScroll" flat height="75px" color="#FBFBFD">
    <v-container class="py-0 fill-height">
      <!-- Logo -->
      <the-logo />

      <!-- Non-mobile header -->
      <!-- Switching the links, depending on the authentication status of the user  -->
      <template v-if="!isMobile">
        <nuxt-link
          v-for="link in links"
          :key="link.target"
          class="studium-navbar-link"
          :class="{ 'studium-navbar-link--active': isRouteActive(link.target) }"
          :to="localePath(link.target)"
        >
          {{ link.name }}
        </nuxt-link>

        <v-spacer />

        <!-- Avatar -->
        <template v-if="$auth.loggedIn">
          <user-avatar />
        </template>

        <!-- Login -->
        <template v-else>
          <v-btn class="studium-button" color="primary" text depressed large :ripple="false" @click="$auth.login()">
            Log in

            <v-icon right medium> mdi-login </v-icon>
          </v-btn>
        </template>

        <!-- Language selector -->
        <language-selector />
      </template>

      <!-- Mobile Header -->
      <template v-else>
        <v-spacer />

        <!-- Hamburger button  -->
        <!-- When button is pressed SideBar.vue is displayed -->
        <v-btn v-if="isMobile" icon large @click="isSidebarOpen = true">
          <v-icon> mdi-menu </v-icon>
        </v-btn>
      </template>
    </v-container>
  </v-app-bar>
</template>

<script lang="ts">
import { computed, defineComponent, useContext, useRoute } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

export default defineComponent({
  props: {
    // Hide the navbar on scroll
    hideOnScroll: {
      type: Boolean,
      default: false,
    },

    // If the sidebar should be shown or hidden.
    sidebar: {
      type: Boolean,
    },
  },
  setup(props, { emit }) {
    const route = useRoute()
    const context = useContext()

    // If the mobile breakpoint is active
    const isMobile = computed(() => {
      return context.$vuetify.breakpoint.smAndDown
    })

    // If the sidebar should be shown or hidden.
    const isSidebarOpen = useVModel(props, 'sidebar', emit)

    // Check if route is active
    function isRouteActive(target) {
      return target === route.value.path
    }

    // Links to display in the navbar.
    const links = computed(() => {
      if (context.$auth.loggedIn) {
        return [
          {
            name: context.i18n.t('navbar.courses'),
            target: '/',
          },
          {
            name: context.i18n.t('navbar.search'),
            target: '/search',
          },
        ]
      } else {
        return [
          {
            name: context.i18n.t('navbar.about'),
            target: '/about',
          },
        ]
      }
    })
    return {
      isMobile,
      isSidebarOpen,
      isRouteActive,
      links,
    }
  },
})
</script>
